(Google translated)

Average Law Synthesizer
===

Github: https://github.com/timcsy/Temperament

Have you ever wondered why there are 12 semitones in the middle of an octave? Can it be other numbers? This plug-in allows you to explore the world of different average laws, and you can also get a set of nice average laws through the calculation of continuous scores.

In addition to the average law, you can also use the fifth-degree symbiotic law to tune, you can get the scales used in many ancient cultures!

In addition, there are many ethnic music that are not 12-tempo, so you can use this useful tool to play music of different cultures. (Example: Chinese pentatonic scales)

If you want to know how to calculate the average rate, why the 12 average rate is good, and the relationship between the continuous score and the average law, and how ancient people used the harmonics to calculate scales, you can refer to the following information:

1. [Mathematics in Scales (1): Generators in Scales (PDF)] (http://mathcenter.ck.tp.edu.tw/Resources/Ctrl/ePaper/ePaperOpenFileX.ashx?autoKey=1007)
2. [Mathematics in Scales (II): How many notes should there be in an octave? (PDF)] (http://mathcenter.ck.tp.edu.tw/Resources/Ctrl/ePaper/ePaperOpenFileX.ashx?autoKey=1008)
3. [Mathematics and Music from Piano Tuning] (http://web.math.sinica.edu.tw/math_media/d331/33102.pdf)
4. [Diophantine Approximation] (https://en.wikipedia.org/wiki/Diophantine Approximation)
5. [Continuous Score] (https://en.wikipedia.org/wiki/Continuous Score)
6. [Natural Harmony: Resonance and Natural Scale] (http://tx.liberal.ntu.edu.tw/TxMusic/Docs/Audio-Harmony_Natural.htm)
7. [Artificial Harmony: Tuning and Digital Scales] (http://tx.liberal.ntu.edu.tw/TxMusic/Docs/Audio-Harmony_Artificial.htm)
8. [Music and Mathematics: From the Voice Inside the String to the Voice Outside the String (PDF)] (https://web.math.sinica.edu.tw/math_media/d181/18111.pdf)

Setting of twelve average laws
! [] (images / EqualTemperament.png)

Import custom scales (Pythagorean tuning is used here)
! [] (images / Pythagorean.png)

Instructions for use
---
Put the plug-in of AU or VST3 (located in plugins / folder) into the appropriate location (depending on the arranger software, there are different installation locations)

Parameter Description:
-Center Frequency: The frequency of the center reference note (the default value is A4 = 440Hz, you can also use C4 = 261.63Hz, or refer to this website: http://www.inspiredacoustics.com/en/MIDI_note_numbers_and_center_frequencies), adjust this Does not affect relative frequency.
-MIDI Note: You can fine-tune for different keyboard positions, and this is the MIDI note number to be edited.
-Note Frequency: This is the frequency setting. It will only change when other parameters are adjusted.
-Index Scale: This is the number of the scale you want to play (the reference tone is at zero), which is the adjustment level (for example: octave)
-Temperament Index: tempIndex: This is the number of the scale you want to play (the reference tone is at zero), which is a small adjustment (for example: semitone in octave)
-Temperament Mode: The tuning method to be used is divided into Equal Temperament (equal law, commonly known as average law), Pythagorean tuning (five-degree symbiotic law, a lot of music in Greece, China, and indigenous people are related to this)
-Center Note: Set the middle note (Note: once this is set, the corresponding position of the previously planned keyboard will return to the original state)
-Partition: a reference interval is divided into several points
-Interval: reference interval
-Scale Unit: used for the 5th phase of the rhythm, used to multiply the next note, if it exceeds the reference interval, divide or multiply by the reference interval, and adjust to the reference interval
-Use Rational: whether to use simple integer ratio for adjustment (when using continuous fraction to find the closest)
-Rational Error: Valid only when Use Rational is enabled.
-Import / Export: There is a keyboard frequency correspondence (only the frequency, scale number, and frequency of the central reference note)
-Main Overtune: used in auxiliary calculations, representing the main overtones, equal to Interval (reference interval)
-Reference Overtune: Used in auxiliary calculations, it refers to reference overtones, and the frequency of the calculated tones is usually the most accurate near the reference overtones.
-Precision: Used in auxiliary calculations, the precision number used in calculating the continuous fraction
-Information on average law: Fraction = calculated continuation fraction, the calculation method can refer to the data [2], Harmonic Note = the most accurate interval, error = the error value of the most accurate interval and the original frequency (divide two overtones)
-Timbre: Tone, Sine Wave, Karplus Strong can be selected
-Decay Factor: The delay factor of the tone

example
---
The examples are located in the examples / folder. There are three examples,
-Sample configuration file (located in config / folder)
-Sample audio file (located in audio / folder)
-Arrangement example (located in LogicProX / folder)


Develop
---
Environmental requirements: JUCE

The root directory contains the Projuce project file, and the source code is located in the Source / folder.
First, create a JUCE Audio Plugin with JUCE project, then
1. Check "VST3" and "AU" in Plugin Formats
2. Check "Plugin is a Synth" and "Plugin MIDI Input" in Plugin Characteristics

If you have any questions about JUCE, you can refer to [Official Website] (https://juce.com/), or see the notes I organized: https://hackmd.io/@timcsy/JUCE

After that, open the IDE and start editing, enjoy it!

License Terms (MIT)
---
Copyright (C) 2019 Zhang Songyu

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge , publish, distribute, sublicense, and / or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
